<?php

/**
 *
 * $Id: class.IllegalArgumentException.php,v 1.1 2005/04/26 05:05:22 dgorski Exp $
 *
 * This file is part of coWiki. coWiki is free software under the terms of
 * the GNU General Public License (GPL). Read the LICENSE file. If you did
 * not receive a copy of the license and are not able to obtain it through
 * the internet, please send a note to <license@cowiki.org> so we can mail
 * you a copy immediately.
 *
 * @package     exception
 * @access      public
 *
 * @author      Daniel T. Gorski, <daniel.gorski@develnet.org>
 * @copyright   (C) Daniel T. Gorski, {@link http://www.develnet.org}
 * @license     http://www.gnu.org/licenses/gpl.html
 * @version     $Revision: 1.1 $
 *
 */

 /**
 * "Illegal argument" exception. Used to indicate passing of broken (wrong
 * type) parameters. Leads usually to program termination and does not
 * need to be caught. In case of passing an illegal argument to a method
 * the program is usually broken.
 *
 * @package     exception
 * @access      public
 *
 * @author      Daniel T. Gorski, <daniel.gorski@develnet.org>
 * @since       coWiki 0.4.0
 */
class IllegalArgumentException extends GenericException {

    /**
     * Class constructor
     *
     * @access  public
     * @param   string  Message for the exception to clarify the cause
     *                  (optional).
     *
     * @author  Daniel T. Gorski, <daniel.gorski@develnet.org>
     * @since   coWiki 0.4.0
     */
    public function __construct($sMsg = null) {
        parent::__construct($sMsg);
        $this->setName(__CLASS__);
    }

} // of class

?>