<?php

/**
 *
 * $Id: class.PrivateAdminCacheEditor.php,v 1.10 2005/02/27 20:35:15 dgorski Exp $
 *
 * This file is part of coWiki. coWiki is free software under the terms of
 * the GNU General Public License (GPL). Read the LICENSE file. If you did
 * not receive a copy of the license and are not able to obtain it through
 * the internet, please send a note to <license@cowiki.org> so we can mail
 * you a copy immediately.
 *
 * <pre>
 * #name:      PrivateAdminCacheEditor
 * #purpose:   Cache management
 * #param:     none
 * #caching:   not used
 * #comment:   none
 * #version:   1.1
 * #date:      14. May 2003
 * #author:    Daniel T. Gorski <daniel.gorski@develnet.org>
 *
 * Please read and understand the README.PLUGIN file before you touch
 * something here.
 * </pre>
 *
 * @package     plugin
 * @subpackage  PrivateAdmin
 * @access      public
 *
 * @author      Daniel T. Gorski, <daniel.gorski@develnet.org>
 * @copyright   (C) Daniel T. Gorski, {@link http://www.develnet.org}
 * @license     http://www.gnu.org/licenses/gpl.html
 * @version     $Revision: 1.10 $
 *
 */

/**
 * coWiki - Cache management
 *
 * @package     plugin
 * @subpackage  PrivateAdmin
 * @access      public
 *
 * @author      Daniel T. Gorski, <daniel.gorski@develnet.org>
 * @since       coWiki 0.3.0
 *
 * @todo        [D11N]  Complete documentation
 */
class PrivateAdminCacheEditor extends AbstractPlugin {

    // Put in the interface version the plugin works with
    const REQUIRED_INTERFACE_VERSION = 1;

    // --------------------------------------------------------------------

    /**
     * Init
     *
     * @access  public
     * @return  mixed
     *
     * @author  Daniel T. Gorski, <daniel.gorski@develnet.org>
     * @since   coWiki 0.3.0
     *
     * @todo    [D11N]  Check description
     * @todo    [D11N]  Check return type
     */
    public function init() {
        return parent::init(self::REQUIRED_INTERFACE_VERSION);
    }

    // --------------------------------------------------------------------

    /**
     * Perform
     *
     * @access  public
     * @return  void
     *
     * @author  Daniel T. Gorski, <daniel.gorski@develnet.org>
     * @since   coWiki 0.3.0
     *
     * @todo    [D11N]  Check description
     */
    public function perform() {

        // Check submission
        if ($this->Request->get('submit') == $this->Context->getSubmitId()) {

            // Main form: CANCEL?
            if ($this->Request->has('button_cancel')
                || $this->Request->has('button_close_x')) {

                // {{{ DEBUG }}}
                Logger::info('Redirecting to controller (CANCEL)');

                // Exit now
                $this->Response->redirectToController();
            }

            // ------------------------------------------------------------

            // Confirmation form: DELETE?
            if ($this->Request->has('button_delete')) {

                $sPath = $this->Context->getTempFileNamePath();

                // Remove all cached files (for all templates and all uids)
                $mFiles = glob($sPath . '*', GLOB_NOSORT);
                if (is_array($mFiles)) {
                    foreach ($mFiles as $sFile) {
                        @unlink($sFile);
                    }
                }

                // {{{ DEBUG }}}
                Logger::info('Redirecting to controller (DELETE)');

                // Exit now
                $this->Response->redirectToController();
            }
        }

        // ----------------------------------------------------------------

        // Form action
        $this->Template->set(
            'TPL_FORM_ACTION',
            $this->Response->getControllerAction()
        );

        $this->Template->set(
            'TPL_ITEM_CONFIRM_HEADER',
            __('I18N_ADMIN_CACHE_HEAD_DELETE')
        );

        $this->Template->set(
            'TPL_ITEM_CONFIRM_TEXT',
            __('I18N_ADMIN_CACHE_CONFIRM_DELETE')
        );

        // Form control data
        $sStr =  '<input type="hidden" name="submit"'
                  .' value="'.$this->Context->getSubmitId().'">';

        $this->Template->set('TPL_FORM_CONTROL_DATA', $sStr);

        // ----------------------------------------------------------------

        // "Delete" resp. "Update" button
        $this->Template->set('TPL_ITEM_BUTTON1_NAME', 'button_delete');
        $this->Template->set('TPL_ITEM_BUTTON1_VALUE', __('I18N_UPDATE'));

        // "Cancel" button
        $this->Template->set('TPL_ITEM_BUTTON2_NAME', 'button_cancel');
        $this->Template->set('TPL_ITEM_BUTTON2_VALUE', __('I18N_CANCEL'));

        // ----------------------------------------------------------------

        // Parse template
        $Tpl = $this->Context->getTemplateProcessor();
        echo $Tpl->parse('plugin.confirm.twobutton.tpl');
    }

} // of plugin component

?>